#include "djstop.h"

char *is_carehost(u_int32_t ip_addr)
{
   PCONT 		temp;
   int bucket_num = 0;

   bucket_num = ip_addr * 3 % HASH_TABLE_SIZE;
   if ( pcont_hash[bucket_num] == NULL) return 0;
   temp = pcont_hash[bucket_num];
   for ( ;; ) {
	   if(temp->ip_addr == ip_addr) {
		   return temp->name;
	   }
	   if (temp->next != NULL) 
		   temp = temp->next;
	   else 
		   break;
   } 
   return NULL;
}
    
char *is_cut_port(u_short port_number)
{
   PPORT 		temp;
   int 			bucket_num = 0;

   bucket_num = port_number * 3 % HASH_TABLE_SIZE;
   if ( pport_hash[bucket_num] == NULL) return 0;
   temp = pport_hash[bucket_num];
   for ( ;; ) {
	   if(temp->port_number == port_number) {
#if	(__DEBUG)
		   fprintf(stdout, "Port matching!! %d\n", temp->port_number);
#endif
		   // allow port ΰ??
		   if ( xflag == 1 )
				return NULL;
		   else
		   		return temp->name;
	   }
	   if (temp->next != NULL) 
		   temp = temp->next;
	   else 
		   break;
   } 

   // allow port ΰ??
   if ( xflag == 1 )
   		return "Denial_of_port";
   else
   		return NULL;
}

char *is_cut_site(u_int32_t ip_addr)
{
   PSITE 		temp;
   int 			bucket_num = 0;

   bucket_num = ip_addr * 3 % HASH_TABLE_SIZE;
   if ( psite_hash[bucket_num] == NULL) return 0;
   temp = psite_hash[bucket_num];
   for ( ;; ) {
	   if(temp->ip_addr == ip_addr) {
		   return temp->domain_name;
	   }
	   if (temp->next != NULL) 
		   temp = temp->next;
	   else 
		   break;
   } 
   return NULL;
}

void check_packet(int sockfd, char *user, int len)  
{
	int		  type;			//  Ʈ or  α׷
	char	  *hostname = NULL;
	char	  *whereis = NULL;
	char      sourceip[25],destip[25];  
	u_short   dest_port, src_port;
	char      date[15]; 
	char      times[15];
	time_t    current;
	struct    tm *ltime;
	char      *service = NULL;
	struct  iphdr  *iph;
	struct  u_layer_hdr *upperh; 
	struct	in_addr addr;

	iph = (struct iphdr *) user;
	// upper layer  4 bytes mapping
	upperh = (struct u_layer_hdr *) (user + iph->ihl * 4);
	
	/* inet_ntoa()  Ҵ  ͸ ȯϱ 
	     ȣϸ  ۿ   ǹǷ, װ
	   ϱ ؼ  ڿ صξ Ѵ.           */
	addr.s_addr = iph->saddr;
	strcpy(sourceip, inet_ntoa(addr));
	addr.s_addr = iph->daddr;
	strcpy(destip, inet_ntoa(addr));	


	//  ȣƮ Ŷ ip ϴ Լ ȣ
	// type = 1 ̸ Source ip address  ȣƮ
	// type = 2 ̸ Destination ip address  ȣƮ
	if ( (hostname = is_carehost(iph->saddr)) == NULL ) {
		if ( (hostname = is_carehost(iph->daddr)) == NULL )
			return;
		else 
			type = 2;	 
	} else 
    	type = 1;

	if(tflag) {
	     send_icmp(sockfd, iph, upperh);
	     fprintf(stdout, "All services is stop! %s --> %s\n", sourceip,destip);
	     return;
	}
	
	if ( mflag )
		fprintf(stdout, "%s(%s) --> %s %hu\n", 
				sourceip, hostname, destip, ntohs(upperh->dest));

   	src_port = ntohs(upperh->source);	
   	dest_port = ntohs(upperh->dest);	
	//   񽺸 ´. logϿ  ʰ Ѵ.
	 if( pflag && (dest_port == 110) ) {
	     send_icmp(sockfd, iph, upperh);
		 fprintf(stdout, "Cut POP3\n");
		 return;
	 }
	//  ۽ 񽺸 ´. logϿ  ʰ Ѵ.
	 if( sflag && (dest_port == 25) ) {
	     send_icmp(sockfd, iph, upperh);
		 fprintf(stdout, "Cut SMTP\n");
		 return;
	 }

	if ( type == 1) {
   		if( (whereis = is_cut_site(iph->daddr)) != NULL ) {
   			if( (cflag || aflag) && (dest_port == 80) ){
       			send_icmp(sockfd, iph, upperh);
#if (__DEBUG)
				fprintf(stderr,"Ok! sent cutting site packet!!\n");
#endif
			}
    	} else if ( (whereis = is_cut_port(dest_port)) != NULL ) {
   			if(cflag || aflag) {
       			send_icmp(sockfd, iph, upperh);
#if (__DEBUG)
				fprintf(stderr,"Ok! sent cutting program packet!!\n");
#endif
			}
			type = 3;
    	} else return;
	// Destination IP Address  ȣƮ̰ 
	// Source port Well-known port ƴѰ(backdoor ɼ)
	} else if ( (type == 2) && (src_port>1024) ) {
		if ( (whereis = is_cut_port(dest_port)) != NULL ) {
   			if( cflag || aflag ) {
       			send_icmp(sockfd, iph, upperh);
#if (__DEBUG)
				fprintf(stderr,"Ok! sent guy cutting backdoor packet!!\n");
#endif
			}
    	} else return;
	}

    current = time(NULL);
    ltime = localtime(&current); 
    strftime(date, 15, "%Y-%m-%d", ltime);  // 1999-08-27
    strftime(times, 15, "%p %l:%M:%S", ltime);         // 17:02:30

	switch (dest_port) {
		case HTTP :
			service = "HTTP";
			break;
		case FTP_CONTROL :
		case FTP_DATA :
			service = "FTP";
			break;
		case TELNET :
			service = "TELNET";
			break;
		case SMTP :
			service = "SMTP";
			break;
		case POP3 :
			service = "POP3";
			break;
		case NNTP :
			service = "NNTP";
			break;
		default :
			service = "Unknown";
			break;
	}
	  
	if ( lflag || aflag ) {
		if ( (type == 1) && (dest_port==HTTP) ) 
			insert_site_log(service, sourceip, whereis, date, times);
		else if ( (type == 2) && (src_port>1024) ) 
			insert_backdoor_log(dest_port, sourceip, destip, whereis, date, times);
		else if ( type == 3 ) 
			insert_program_log(dest_port, sourceip, whereis, date, times);
	}

	if ( (type == 1) && (dest_port==HTTP) ) {
		if ( cflag || aflag)
			fprintf(stdout, "%ld : Cut  %15s(%s) --> %-20s  %-7s %-15s\n", 
					pthread_self(), sourceip, hostname, whereis, service, times);
	    else
			fprintf(stdout, "     %15s(%s) --> %-20s  %-7s %-15s\n", 
					sourceip, hostname, whereis, service, times);
	}
	else if ( ((type == 2)&&(src_port>1024)) || (type == 3) ) {
		if ( cflag || aflag)
			fprintf(stdout, "%ld : Cut  %15s --> %-15s(%s)  %-6d %-15s\n", 
					pthread_self(), sourceip, destip, whereis, dest_port, times);
		else
			fprintf(stdout, "     %15s --> %-15s(%s)  %-6d %-15s\n", 
					sourceip, destip, whereis, dest_port, times);
	}
}
