#include "djstop.h"

int nthreads = 3;
int main_thread_number;

void usage(void)
{
    fprintf(stdout, " : djstop [-clapstme]\n");
    fprintf(stdout, "        -a  :  ,   Ѵ ϱ\n"); 
    fprintf(stdout, "        -c  :  ܸ ϱ\n"); 
    fprintf(stdout, "        -l  :  ϸ ϱ\n"); 
    fprintf(stdout, "        -x  :   port   tcp service  ϱ\n"); 
    fprintf(stdout, "        -p  :  pop3 (ϼ )\n"); 
    fprintf(stdout, "        -s  :  smtp (ϼ۽ )\n"); 
    fprintf(stdout, "        -t  :   ͳ  ߴ\n"); 
    fprintf(stdout, "        -m  :   ͸\n"); 
    fprintf(stdout, "        -e count :    thread \n"); 
    fprintf(stdout, "        -i interface : Ethernet interface\n"); 
    fprintf(stdout, "        -w : Support switching envirunment\n"); 
}

int main(int argc, char *argv[])
{
	struct	bpf_program fcode;
	char	*device = NULL;
	char	*filter_rule;
	char    ebuf[PCAP_ERRBUF_SIZE];
	int		i, snaplen = 68, opt;
	bpf_u_int32 localnet, netmask;
	
	if ( ( site_fp = fopen("site.log", "a+") ) == NULL) {
		fprintf(stderr, "Can't open http_log.dat file\n");
		exit(1);
	}
        
	if ( ( program_fp = fopen("program.log", "a+") ) == NULL) {
		fprintf(stderr, "Can't open http_log.dat file\n");
		exit(1);
	}

	if ( ( backdoor_fp = fopen("backdoor.log", "a+") ) == NULL) {
		fprintf(stderr, "Can't open http_log.dat file\n");
		exit(1);
	}

    /*----------------------------------------------
      tcp  syn set packet ͸Ѵ 
     ----------------------------------------------*/
	filter_rule = "tcp and tcp[13:1] & 2 != 0";
	
	if(argc-1 < 1) {
	    usage();
	    exit(1);
	}
	
	while( ( opt = getopt(argc, argv, "pstmclaxwe:i:")) != -1) {
	    switch(opt) {
		case 'm' :      // ǽð ͸             
			mflag = 1; break; 
		case 'c' :      // ܸ ϱ                 
			cflag = 1; break; 
		case 'l' :      // ϸ ϱ                  
			lflag = 1; break; 
		case 'a' :      // Ѵ ϱ                   
			aflag = 1; break; 
		case 'x' :      // Ѵ ϱ                   
			xflag = 1; break; 
		case 'p' :      //   (POP3)
			pflag = 1; break; 
		case 's' :      //  ۽ (SMTP)
			sflag = 1; break; 
		case 't' :      //  ͳ  (tcp)
			tflag = 1; break; 
		case 'w' :      // Switching ȯ ϱ
			wflag = 1; break; 
		case 'e' :      // Engine thread 
			nthreads = atoi( optarg );
			break;
		case 'i': // ethernet interface 
			device = optarg;
			break;
	    }
	}

	if ( wflag )
		set_ip_forward(1);	// ip_forward Ŀ  (enabled)

	init_scheduling();		// schedule.conf  о 층 data Ѵ.
	load_site_list();		//  Ʈ  о鿩 ؽ ̺ Ѵ.
	load_port_list();		//  Ʈ  о鿩 ؽ ̺ Ѵ.
	load_cont_list();		//  ȣƮ  о鿩 ؽ ̺ Ѵ.

	//  ɼ ̽  ʾ  ⺻ ̽ ´.
	if ( device == NULL && (device = pcap_lookupdev(ebuf)) == NULL)
		perror(ebuf);

	/*------------------------------------------------------------ 
	   ⸦ ش.
	   snaplen Ŷ  Ʈ 
	   100̶ ڴ ̽  ִ ۰  
	   ۰ 鼭 ͸ о   ִµ Ŷ 
	   ʴ  ۰ ä   Ŷ  ϹǷ,
	    ͸ ó ϴ  ߻Ѵ.  
	   ŸӾƿ  ־  ð  ͸ о̵
	   ϱ  ð ̴.
	   ----------------------------------------------------------*/
	pd = pcap_open_live(device, snaplen, PROMISCUOUS, 100, ebuf);
	if(pd == NULL) {
   		perror(ebuf);          
   		exit(1);
   	}
	
	i = pcap_snapshot(pd);
	if(snaplen < i) {
   		perror(ebuf);                            
  		exit(1);
   	}
	// Ŷ ĸ ⿡ Ʈũ ּҿ  ũ ˾Ƴ.	
	if(pcap_lookupnet(device, &localnet, &netmask, ebuf) < 0) {
   		perror(ebuf);
   		exit(1);
   	}
	
	//  꿡   α׷ Ѵ.
	if(pcap_compile(pd, &fcode, filter_rule, 0, netmask) < 0) {
   		perror(ebuf);
   		exit(1);
   	}
	//  Ŷ  α׷ Ŷ ĸı оδ.
	if(pcap_setfilter(pd, &fcode) < 0) {
   		perror(ebuf);
   		exit(1);
   	}

	datalink = pcap_datalink(pd);
	
	fflush(stderr);

	tptr = calloc(nthreads, sizeof(Thread));

	for ( i=0; i<nthreads; i++ )
		if ( pthread_create(&tptr[i].tid, NULL, &packet_loop, (void *) i) )
			fprintf(stderr,"Thread creation error!\n");

	signal(SIGHUP, sig_int);		// hang up
	signal(SIGINT, sig_int);		// Ctrl-C
	signal(SIGTERM, sig_int);		// kill command

	main_thread_number = pthread_self();

	for(;;)
	    pause(); // signal  ߻Ҷ main thread  Ų.
}

void sig_int(int sig)
{
    int i;
   
	if ( main_thread_number == pthread_self() ) {
		for(i=0; i<nthreads; i++)
			pthread_join(tptr[i].tid, NULL);
	
		fclose(site_fp);
		fclose(program_fp);
		fclose(backdoor_fp);
		set_ip_forward(0);	// disable ip_forward
		fprintf(stderr, "Bye!\n"); 
		exit(0); 
	} else {
		pthread_exit(0);
	}
}

