#ifndef  __ARP_SPOOF_H
#define	 __ARP_SPOOF_H

#include <sys/types.h>
#include <string.h>
#include <signal.h>
#include <sys/param.h>
#include <sys/socket.h>
#include <sys/sysctl.h>
#include <net/route.h>
#include <sys/ioctl.h>
#include <net/if.h>
#include <netinet/in.h>
#include <netinet/if_ether.h>
#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <pcap.h>
#include <libnet.h>

typedef struct switch_node *PSWITCH;
struct switch_node {
	uint32_t		  ip_addr;
	u_char 			  mac_addr[6];
	PSWITCH			  next;
};
PSWITCH root;

int arp_force(uint32_t); 
int arp_find(uint32_t, struct ether_addr *);
int arp_cache_lookup(uint32_t, struct ether_addr *);
int arp_send(struct libnet_link_int *, char *, int, u_char *, uint32_t, u_char *, uint32_t);
void make_switching_list(uint32_t, u_char *);
char *ether_ntoa(struct ether_addr *e);
struct ether_addr *ether_aton(char *s);

#endif 	/*	__ARP_SPOOF_H	*/
