/* url ̿Ͽ ip adress    Ʈ Ͽ
 * ߰ ִ α׷
 * UNIX NETWORK PROGRAMMING Volume 1 Second Edition P.244 */

#include "../djstop.h"

int main(int argc, char *argv[])  
{
   	char *ptr, **pptr;
	char str[16];
	struct hostent *hptr;
	FILE *site_fp;
	
	//  Ʈ    append mode
	if ( ( site_fp = fopen("site_list.dat", "a+") ) == NULL) {
		fprintf(stderr, "Can't open site_list.dat file\n");
		exit(1);
	}

	if ( argc-1 < 1 ) {
		fprintf(stderr, "Usage : %s url [url....]\n", argv[0]);
		exit(0);
	}

	// ־ url  ó  while loop
	while (--argc > 0 ) {
		ptr = *++argv;
		// Url ʹ    
		//  50  Ҵ.
		if ( strlen(ptr) > 50 ) {
			fprintf(stderr, "Inappropriate address for insert_ip.\n");
			fprintf(stderr, "Usage : ./insert_ip url [url....]\n");
		    exit(0);
		}

		if ( (hptr = gethostbyname(ptr)) == NULL ) {
			fprintf(stderr,"gethostbyname error for host : %s\n", ptr);
			continue;
		}
		fprintf(stdout,"Official hostname: %s\n", hptr->h_name);

		for (pptr = hptr->h_aliases; *pptr != NULL; pptr++)
			fprintf(stdout,"\talias: %s", *pptr);

		pptr = hptr->h_addr_list;
		for ( ; *pptr != NULL; pptr++) {
			fprintf(stdout,"\taddress: %s\n", inet_ntop(hptr->h_addrtype, *pptr, str, sizeof(str)));
			fprintf(site_fp, "%s\t\t%s\n", ptr, str);
		}
	}
	exit(0);
}
